<template>
    <div class="page-container">
        <div class="d-flex list wrap">
            <div class="card d-flex flex-column m-20 radius" v-for="product, id in products" :key="id">

                <div class="top">
                    <div class="card-title">
                        <img class="img-type" :class="product.type" :src="iconSrc(product.type).value" alt="icon-food" />
                        <span>{{product.name}}</span>
                    </div>
                    <div class="crud-container">
                        <RouterLink :to="('/editproduct/'+product.id)"><button><img class="crud-btn edit" src="../../assets/svg/icons/pencil.svg" alt="icon-food" /></button></RouterLink>
                        <button @click="deleteProduct(product.id)"><img class="crud-btn delete" src="../../assets/svg/icons/trash.svg" alt="icon-food" /></button>
                    </div>
                </div>
                <div class="bottom">
                    <span v-if="product.quantity < product.ProductAlert.limit_quantity" style="color: red;">Nb : {{product.quantity}}</span>
                    <span v-else>Nb : {{product.quantity}}</span>
                    <span> {{formatDate(product)}}</span>
                    <!-- <span v-else> {{formatDate(product)}}</span> -->
                </div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { useUser } from '@/shared/stores/userStore';
import { ref, computed } from 'vue'
import type {Product} from '../../shared/interfaces/index'
import steakIcon from '../../assets/svg/icons/steak.svg';
import ketchupIcon from '../../assets/svg/icons/ketchup.svg';
import fishIcon from '../../assets/svg/icons/fish-5.svg';
import drinkIcon from '../../assets/svg/icons/soft-drinks.svg';
import cheeseIcon from '../../assets/svg/icons/cheese.svg';
import dairyIcon from '../../assets/svg/icons/milk.svg';
import fruitIcon from '../../assets/svg/icons/fruit.svg';
import vegetableIcon from '../../assets/svg/icons/broccoli.svg';

const BASE_URL = import.meta.env.VITE_BASE_URL;
const UserStore = useUser();
const products = ref<Product[]>([])

// Fetch all products
const fetchProducts = () => {
    fetch(BASE_URL + 'products',{
        headers:{
            authorization: `Bearer ${UserStore.token}`
        }
})
    .then(res => res.json())
        .then(json => products.value = json)
        .catch(err => console.log(err))
}

fetchProducts()

const deleteProduct = (ProductId: number) =>{
    if(ProductId){
            fetch(`${BASE_URL}products/${ProductId}`,{
            method: 'DELETE'
        }).then(() => {
            const id = products.value.findIndex((products) => products.id == ProductId)
            products.value.splice(id, 1)
    })
  }
}


// Format expiration date in locale Date
const formatDate = (product:Product) => {
    if(product.ExpirationAlert)
    return  new Date(product.ExpirationAlert?.expiration_alert).toLocaleDateString()
    else{
        return "Aucune date"
    }
}

const compareDate = (product:Product) => {
    if(product.ExpirationAlert)
    return  new Date(product.ExpirationAlert?.expiration_alert).getTime()
}

const currentDate = new Date();

// icon for type of food
const iconMap: {[key: string]: string} = {
  viande: steakIcon,
  condiment: ketchupIcon,
  poisson: fishIcon,
  boisson: drinkIcon,
  fromage: cheeseIcon,
  "produits laitiers": dairyIcon,
  fruit: fruitIcon,
  legume: vegetableIcon
};

const iconSrc = (type: string) => computed(() => iconMap[type]);
  
</script>

<style scoped lang="scss">

    .list{
        justify-content: space-evenly;
        max-width: 1400px;
        text-align: center;
        .card{
            justify-content: space-around;
            align-items: flex-start;
            width: 320px;
            height: 150px;
            .top{
                display: flex;
                justify-content: space-between;
                width: 100%;
                align-items: center;
                padding-left: 2rem;
                .card-title{
                    display: flex;
                    align-items: center;
                    gap: 10px;
                }
                .crud-container{
                    position: relative;
                    bottom: 25px;
                    right: 5px;
                    .crud-btn{
                        width: 20px;
                        cursor: pointer;
                    }
                    .edit{
                        filter: invert(56%) sepia(99%) saturate(689%) hue-rotate(352deg) brightness(103%) contrast(94%);
                    }
                    .delete{
                        filter: invert(18%) sepia(90%) saturate(2187%) hue-rotate(355deg) brightness(108%) contrast(90%);
                    }
                }
                .img-type{
                    width: 50px;
                }
            }
            .top:first-child{
                margin-right: auto;
            }
            .top:last-child{
                margin-left: auto;
            }
            .bottom{
                display: flex;
                width: 100%;
                align-items: center;
                justify-content: space-evenly;
            }
        }
    }

    span{
        font-weight: 700;
        font-size: 20px;
        line-height: 23px;
    }

    button{
        background: none;
        border: none;
    }

</style>
